'=================================================
'                 
'               Arduino Pro mini
'        MAX7456 + DS1307 + DHT22 + BMP085
'           Lao (klazarev@gmail.com) 2014
'=================================================
'=                                 =
'=           MAX7456 Video overlay Demo          =
'=            By EvertDekker.com 2009            =
'=================================================
'=       DS1307    =
'=  "  8, DS1307   Nokia1100"  =
'=            (Gordon Shumway)            =
'=        c c  http://bascom.at.ua/          =
'=================================================
'=    DHT22   kip96   =
'=           http://avrproject.ru/               =
'=================================================
'=                BMP085          =
'=            2013 (C) Antonio Paulo Hawk        =
'=         2014 (C) Konstantin Lazarev aka Lao   =
'=================================================

$regfile = "m328pdef.DAT"
$crystal = 16000000
$baud = 9600
$hwstack = 150
$swstack = 150
$framesize = 100

'* * *   ds1307
$lib "ds1307clock.lib"
'$lib "mcsbyte.lbx"

Config Sda = Portc.4
Config Scl = Portc.5

Config Clock = User

Config Int0 = Rising
On Int0 Startds Nosave

' 
Config Pind.3 = Input
Config Pind.4 = Input
Config Pind.5 = Input
Setting Alias Pind.3
Plus Alias Pind.5
Minus Alias Pind.4

' C
Config Pinb.1 = Output
Led Alias Pinb.1

' DHT22  PortD.6
Config Pind.6 = Input


Config Pind.7 = Input
Vsync Alias Pind.7

'     ds1307
Const Ds1307w = &HD0                                                                      '  
Const Ds1307r = &HD1                                                                      '  

Const Bmp085_read = &HEF                                                                  'BMP085 Read Address
Const Bmp085_write = &HEE                                                                 'BMP085 Write Address

Config Spi = Hard , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 16 , Noss = 0 'Setup the hardware spi
Spiinit

'===   MAX7456 ===
Dim I As Byte
Dim Bytetemp As Byte
Dim Regaddr As Byte
Dim Regdata As Byte
Dim Buffer(2) As Byte
Dim Temptext As String * 16
Dim Bittemp As Bit
Dim Wordtemp As Word
Dim Integertemp As Integer
Dim Vosreg As Byte , Hosreg As Byte

'==============================

'===   MAX7456 ===
Const Vm0 = &H00                                                                          '  1
Const Vm1 = &H01                                                                          '  2
Const Hos = &H02                                                                          'Horizontal Offset
Const Vos = &H03                                                                          'Vertical Offset
Const Dmm = &H04                                                                          'Display Memory Mode
Const Dmah = &H05                                                                         'Display Memory Address High
Const Dmal = &H06                                                                         'Display Memory Address Low
Const Dmdi = &H07                                                                         'Display Memory Data In
Const Cmm = &H08                                                                          'Character Memory Mode
Const Cmah = &H09                                                                         'Character Memory Address High
Const Cmal = &H0A                                                                         'Character Memory Address Low
Const Cmdi = &H0B                                                                         'Character Memory Data In
Const Osdm = &H0C                                                                         'Osd Insertion Mux
Const Osdbl = &H6C                                                                        'OSD Black Level

'==============================

'===   DHT22 ===
Dim Count As Byte
Dim D As Byte
'Dim Kod As Dword At $11e
'Dim Hb(5) As Byte At $11d Overlay
Dim Kod As Dword At $13f
Dim Hb(5) As Byte At $13e Overlay
Dim Hu(2) As Word At Kod Overlay
Dim Chs As Byte
Dim Hum_s As String * 4
Dim Temp_s As String * 4
Dim Strstring As String * 14
Dim Ib As Byte
Dim Hum As Single
Dim Tempout As Integer
Dim Tempmin As Integer
Dim Tempmax As Integer
Dim Etempmin As Eram Integer
Dim Etempmax As Eram Integer

Const Min_time = 3
'============================


' ===   DS1307 ===
Dim Ho As Byte
Dim Mi As Byte
Dim Secu As Byte
Dim Day As Byte
Dim Dat As Byte
Dim Mo As Byte
Dim Ye As Byte


Dim Hour As String * 2
Dim Minute As String * 2
Dim Second As String * 2
Dim Days As String * 2
Dim Month As String * 2
Dim Year As String * 2
Dim Weekday As String * 8
Dim Strday As String * 16
Dim Strdat As String * 2
Dim Strmo As String * 10
Dim Strye As String * 3
Dim Strdate As String * 8


Dim N As Byte

Dim Bit7 As Bit

Dim Dig As String * 1

Dim Wt As Word
'==============================


'===   BMP085 ===
Dim I2c_send_buf(5) As Byte
Dim I2c_receive_buf(5) As Byte
Dim M As Bit


'Calibration data variables
'Overlay used for easy access

Dim Calibration_data(22) As Byte
Dim Ac1 As Integer At Calibration_data(1) Overlay
Dim Ac2 As Integer At Calibration_data(1) + 2 Overlay
Dim Ac3 As Integer At Calibration_data(1) + 4 Overlay
Dim Ac4 As Word At Calibration_data(1) + 6 Overlay
Dim Ac5 As Word At Calibration_data(1) + 8 Overlay
Dim Ac6 As Word At Calibration_data(1) + 10 Overlay
Dim B1 As Integer At Calibration_data(1) + 12 Overlay
Dim B2 As Integer At Calibration_data(1) + 14 Overlay
Dim Mb As Integer At Calibration_data(1) + 16 Overlay
Dim Mc As Integer At Calibration_data(1) + 18 Overlay
Dim Md As Integer At Calibration_data(1) + 20 Overlay

Dim C3 As Single
Dim C4 As Single
Dim B11 As Single
Dim C5 As Single
Dim C6 As Single
Dim Mc1 As Single
Dim Md1 As Single
Dim X0 As Single
Dim X1 As Single
Dim X2 As Single
Dim Y0 As Single
Dim Y1 As Single
Dim Temp As Single
Dim P0 As Single
Dim P1 As Single
Dim P2 As Single


Dim Y2 As Single
Dim Alfa As Single
Dim Temp1 As Single
Dim S As Single
Dim X As Single
Dim Y As Single
Dim Z As Single
Dim Tu As Single
Dim Pu As Single
Dim Pv As Long
Dim P_corrv As Long
Dim Tv As Long

Dim U_temperatur As Long
Dim U_temp_low As Byte At U_temperatur Overlay
Dim U_temp_high As Byte At U_temperatur + 1 Overlay

Dim T As Single

Dim U_pressure As Long
Dim U_pressure_low As Byte At U_pressure Overlay
Dim U_pressure_mid As Byte At U_pressure + 1 Overlay
Dim U_pressure_high As Byte At U_pressure + 2 Overlay


Dim P As Single
Dim Pl As Byte
Dim Pl1 As Byte
Dim Pl2 As Byte
Dim Pl3 As Byte
Dim Pl4 As Byte
Dim Pl5 As Byte
Dim Pl6 As Byte
Dim Pl7 As Byte
Dim Pl8 As Byte
Dim Pl9 As Byte
Dim Pl10 As Byte
Dim Pl11 As Byte
Dim Pl12 As Byte
Dim Tlog As Byte

Dim Epl As Eram Byte
Dim Epl1 As Eram Byte
Dim Epl2 As Eram Byte
Dim Epl3 As Eram Byte
Dim Epl4 As Eram Byte
Dim Epl5 As Eram Byte
Dim Epl6 As Eram Byte
Dim Epl7 As Eram Byte
Dim Epl8 As Eram Byte
Dim Epl9 As Eram Byte
Dim Epl10 As Eram Byte
Dim Epl11 As Eram Byte
Dim Epl12 As Eram Byte

'absolute altitude
Dim Altitude As Single
Dim P_corr As Single

Dim Temperature As String * 8
Dim Pressure As String * 8
'=============================


'====    
Dim Moonday As Single
Dim Phase As Byte
'=====================================
'====     ===
'Dim Wa As Integer
'Dim Wy As Integer
'Dim Wm As Integer
'Dim Wtemp1 As Integer
'Dim Wtemp2 As Integer
'Dim Wtemp3 As Integer
'Dim Wtemp4 As Integer
'Dim Wtemp5 As Single
'Dim Wd As Byte


'===   MAX7456 ===
Declare Sub Initmax7456()
Declare Sub Videotext(byval Text As String , Byval Ypos As Byte , Byval Xpos As Byte , Byval Blnk As Byte , Byval Inv As Byte )
Declare Sub Videochar(byval Char As Byte , Byval Ypos As Byte , Byval Xpos As Byte , Byval Blnk As Byte , Byval Inv As Byte)
Declare Sub Writereg(byval Regaddr As Byte , Byval Regdata As Byte)
Declare Sub Print_big_digit(byval Digit As Byte , Byval Yp As Byte , Byval Xp As Byte , Byval Blnk As Byte)
Declare Sub Print_digit(byval Digit As Byte , Byval Yp As Byte , Byval Xp As Byte)
'================================

'===   BMP085 ===
Declare Sub Bmp085_read_calibration_data()
Declare Sub Bmp085_initiate_measurement(byval Measurement_type As Byte)
'Measurement_type = 1 --> Temparature Measurement
'Measurement_type = 2 --> Ultra Low Power Pressure Measurement (OSS = 0)
'Measurement_type = 3 --> Standard Pressure Measurement (OSS = 1)
'Measurement_type = 4 --> High Resolution Pressure Measurement (OSS = 2)
'Measurement_type = 5 --> Ultra High Resolution Pressure Measurement (OSS = 3)

Declare Sub Bmp085_read_u_temp()                                                          'Read uncompensated Temp Value
Declare Sub Bmp085_read_u_press()                                                         'Read uncompensated Pressure Value
Declare Sub Bmp085_calc_temp()                                                            'Calculate Temperature
Declare Sub Bmp085_calc_pressure()
'===============================

Declare Sub Read_dht22

Declare Sub Print_phase(byval Digit As Byte , Byval Yp As Byte , Byval Xp As Byte)

'  Sout 1hz  DS1307
I2cstart
I2cwbyte Ds1307w
I2cwbyte 7
I2cwbyte &B00010000
I2cstop

' 7    DS1307
'   1,  DS1307    
'    3 

I2cstart
I2cwbyte Ds1307w
I2cwbyte &H00
I2cstart
I2cwbyte Ds1307r
I2crbyte Secu , Nack
I2cstop

Bit7 = Secu.7

If Bit7 = 1 Then

'  7  1,    DS1307 00:00:00 1  2014, .
'   0 -  DS1307

Ho = Makebcd(0)
Mi = Makebcd(0)
Day = Makebcd(4)
Dat = Makebcd(1)
Mo = Makebcd(5)
Ye = Makebcd(14)

 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 0
 I2cwbyte 0
 I2cwbyte Mi
 I2cwbyte Ho
 I2cwbyte Day
 I2cwbyte Dat
 I2cwbyte Mo
 I2cwbyte Ye
 I2cstop


I2cstart
I2cwbyte Ds1307w
I2cwbyte 0
I2cwbyte &B00000000
I2cstop

End If


'=== Setup ===
$include Calibration.bas
Initmax7456                                                                               'Init the Max7456
Waitms 100

Reset Led
Wt = 400                                                                                  '   


' ===     ===
M = 0

Videochar &H9D , 0 , 0 , 0 , 0
Videochar &H9E , 0 , 29 , 0 , 0
Videochar &H9C , 15 , 0 , 0 , 0
Videochar &H9F , 15 , 29 , 0 , 0

For Bytetemp = 1 To 14
Videochar &H98 , Bytetemp , 0 , 0 , 0
Videochar &H99 , Bytetemp , 29 , 0 , 0
Next Bytetemp

For Bytetemp = 1 To 28
Videochar &H9A , 0 , Bytetemp , 0 , 0
Videochar &H9B , 15 , Bytetemp , 0 , 0
Videochar &HAA , 6 , Bytetemp , 0 , 0
Videochar &HAA , 3 , Bytetemp , 0 , 0
Videochar &HAA , 8 , Bytetemp , 0 , 0

Next Bytetemp

Videochar &HA9 , 6 , 0 , 0 , 0
Videochar &HAB , 6 , 29 , 0 , 0

Videochar &HA9 , 3 , 0 , 0 , 0
Videochar &HAB , 3 , 29 , 0 , 0

Videochar &HA9 , 8 , 0 , 0 , 0
Videochar &HAB , 8 , 29 , 0 , 0

'=== 
Videochar &H41 , 1 , 12 , 0 , 0
Videochar &H42 , 1 , 13 , 0 , 0
Videochar &H43 , 1 , 14 , 0 , 0
Videochar &H44 , 1 , 15 , 0 , 0
Videochar &H45 , 1 , 16 , 0 , 0
Videochar &H46 , 2 , 12 , 0 , 0
Videochar &H47 , 2 , 13 , 0 , 0
Videochar &H48 , 2 , 14 , 0 , 0
Videochar &H49 , 2 , 15 , 0 , 0
Videochar &H4A , 2 , 16 , 0 , 0
Videochar &H4B , 3 , 12 , 0 , 0
Videochar &H4C , 3 , 13 , 0 , 0
Videochar &H4D , 3 , 14 , 0 , 0
Videochar &H4E , 3 , 15 , 0 , 0
Videochar &H4F , 3 , 16 , 0 , 0
Videochar &H50 , 4 , 12 , 0 , 0
Videochar &H51 , 4 , 13 , 0 , 0
Videochar &H52 , 4 , 14 , 0 , 0
Videochar &H53 , 4 , 15 , 0 , 0
Videochar &H54 , 4 , 16 , 0 , 0

Videochar &H2F , 3 , 17 , 0 , 0


'===  
Videochar &HBA , 1 , 1 , 0 , 0
Videochar &HBB , 1 , 2 , 0 , 0
Videochar &HBC , 1 , 3 , 0 , 0
Videochar &HBD , 2 , 1 , 0 , 0
Videochar &HBE , 2 , 2 , 0 , 0
Videochar &HBF , 2 , 3 , 0 , 0

'===  
Videochar &HA0 , 4 , 1 , 0 , 0
Videochar &HA1 , 4 , 2 , 0 , 0
Videochar &HA2 , 4 , 3 , 0 , 0
Videochar &H00 , 5 , 1 , 0 , 0
Videochar &HA4 , 5 , 2 , 0 , 0
Videochar &HA5 , 5 , 3 , 0 , 0

'===  
Videochar &HA3 , 1 , 26 , 0 , 0
Videochar &H96 , 1 , 27 , 0 , 0
Videochar &H97 , 1 , 28 , 0 , 0
Videochar &H23 , 2 , 26 , 0 , 0
Videochar &HA6 , 2 , 27 , 0 , 0
Videochar &HA7 , 2 , 28 , 0 , 0
Videochar &H3E , 2 , 23 , 0 , 0

'===  
Videochar &HA3 , 4 , 26 , 0 , 0
Videochar &H96 , 4 , 27 , 0 , 0
Videochar &H97 , 4 , 28 , 0 , 0
Videochar &H22 , 5 , 26 , 0 , 0
Videochar &H95 , 5 , 27 , 0 , 0
Videochar &HA7 , 5 , 28 , 0 , 0
Videochar &H3E , 5 , 23 , 0 , 0
'=================================

' ===  
'Videochar &H25 , 7 , 1 , 0 , 0
Videochar &H5A , 7 , 0 , 0 , 0
Videochar &H59 , 6 , 1 , 0 , 0
Videochar &H5B , 7 , 1 , 0 , 0
Videochar &H58 , 8 , 1 , 0 , 0

'Videochar &H2E , 7 , 5 , 0 , 0
Videochar &H5C , 6 , 7 , 0 , 0
Videochar &H5D , 7 , 7 , 0 , 0
Videochar &HAE , 6 , 8 , 0 , 0
Videochar &H5E , 7 , 8 , 0 , 0
Videochar &HAD , 8 , 8 , 0 , 0

' ===  
'Videochar &H26 , 7 , 22 , 0 , 0
Videochar &H56 , 7 , 21 , 0 , 0
Videochar &H55 , 6 , 22 , 0 , 0
Videochar &H57 , 7 , 22 , 0 , 0
Videochar &H58 , 8 , 22 , 0 , 0

'Videochar &H2E , 7 , 26 , 0 , 0
Videochar &H5C , 6 , 28 , 0 , 0
Videochar &H5D , 7 , 28 , 0 , 0
Videochar &HAE , 6 , 21 , 0 , 0
Videochar &H5F , 7 , 29 , 0 , 0
Videochar &HAD , 8 , 21 , 0 , 0

If Minus = 0 Then
 Etempmax = -200
 Etempmin = 200
' Eznakmin = 0
' Eznakmax = 1
 Epl12 = 9
 Epl11 = 8
 Epl10 = 6
 Epl9 = 4
 Epl8 = 2
 Epl7 = 1
 Epl6 = 1
 Epl5 = 2
 Epl4 = 4
 Epl3 = 6
 Epl2 = 8
 Epl1 = 9
End If

Tempmax = Etempmax
Tempmin = Etempmin
'Znakmin = Eznakmin
'Znakmax = Eznakmax


Pl12 = Epl12
Pl11 = Epl11
Pl10 = Epl10
Pl9 = Epl9
Pl8 = Epl8
Pl7 = Epl7
Pl6 = Epl6
Pl5 = Epl5
Pl4 = Epl4
Pl3 = Epl3
Pl2 = Epl2
Pl1 = Epl1

Gosub Dht22
'Gosub Tempminmax
Gosub Presslog

Call Bmp085_read_calibration_data()
Gosub Bmp085
'Waitms 100
'Gosub Dht22
'Waitms 100

'Gosub Dht22
Main:

Gosub Gettime
Gosub Printsecond
Gosub Printminute
Gosub Printhour
Gosub Printday
Gosub Printdat
Gosub Printmonth
Gosub Printyear
Gosub Printmoonday

Enable Interrupts
Enable Int0

Do                                                                                        ' .
M = 1
If Setting = 0 Then Gosub Settime                                                         '  " "

Loop

Startds:                                                                                  '   INT0    ,       
Toggle Led

Gosub Gettime

N = 0

Gosub Printsecond
'Gosub Dht22
If Secu = 0 Then Gosub Printminute
If Secu = 1 And Mi = 0 Then Gosub Printhour
If Secu = 2 And Mi = 0 And Ho = 0 Then Gosub Printday
If Secu = 3 And Mi = 0 And Ho = 0 Then Gosub Printdat
If Secu = 4 And Mi = 0 And Ho = 0 Then Gosub Printmoonday
If Secu = 5 And Mi = 0 And Ho = 0 And Dat = 1 Then Gosub Printmonth
If Secu = 6 And Mi = 0 And Ho = 0 And Dat = 1 Then Gosub Printyear
If Secu = 15 Or Secu = 45 Then Gosub Bmp085
If Secu = 0 Or Secu = 30 Then Gosub Dht22
If Secu = 46 And Mi = 0 And Ho = 3 Then Tempmax = Tempout                                 '         24- 
If Secu = 47 And Mi = 0 And Ho = 15 Then Tempmin = Tempout                                '        24- 
If Secu = 50 And Mi = 0 Then
   Etempmin = Tempmin
   Etempmax = Tempmax                                                                     '      Tempmin  Tempmax  EEPROM 
End If
Tlog = Ho Mod 6                                                                           '    ?
If Secu = 18 And Mi = 0 And Tlog = 0 Then Gosub Presslog                                  ' !
Return

Settime:
M = 0
' ,    
'Pind.3 -  , pind.4  5 -   .

Disable Interrupts
Disable Int0

Waitms Wt                                                                                 '     

N = 1 : Gosub Printhour

Do                                                                                        ' 

If Plus = 0 Then
Ho = Ho + 1
If Ho > 23 Then Ho = 0
N = 1 : Gosub Printhour

Waitms Wt
End If

If Minus = 0 Then
Ho = Ho - 1
If Ho > 23 Then Ho = 23
N = 1 : Gosub Printhour

Waitms Wt
End If

If Setting = 0 Then
Waitms Wt
Goto Setminute
End If

Loop

Setminute:

N = 0 : Gosub Printhour
N = 1 : Gosub Printminute

Do                                                                                        '  

If Plus = 0 Then
Mi = Mi + 1
If Mi > 59 Then Mi = 0
N = 1 : Gosub Printminute
Waitms Wt
End If

If Minus = 0 Then
Mi = Mi - 1
If Mi > 59 Then Mi = 59
N = 1 : Gosub Printminute
Waitms Wt
End If

If Setting = 0 Then
Waitms Wt
Goto Setdat
End If

Loop

Setdat:

N = 0 : Gosub Printminute
N = 1 : Gosub Printdat

Do                                                                                        '  

If Plus = 0 Then
 Dat = Dat + 1
 If Dat > 31 Then
  Dat = 1
 End If
N = 1 : Gosub Printdat
Gosub Printday
Gosub Printmoonday
Waitms Wt
End If

If Minus = 0 Then
Dat = Dat - 1
If Dat < 1 Then Dat = 31
N = 1 : Gosub Printdat
Gosub Printday
Gosub Printmoonday
Waitms Wt
End If

If Setting = 0 Then
Waitms Wt
Goto Setmonth
End If

Loop

Setmonth:                                                                                 '  

N = 0 : Gosub Printdat
N = 1 : Gosub Printmonth

Do

If Plus = 0 Then
Mo = Mo + 1
If Mo > 12 Then Mo = 1
N = 1 : Gosub Printmonth
Gosub Printmoonday
Waitms Wt
End If

If Minus = 0 Then
Mo = Mo - 1
If Mo < 1 Then Mo = 12
N = 1 : Gosub Printmonth
Gosub Printmoonday
Waitms Wt
End If

If Setting = 0 Then
Waitms Wt
Goto Setyear
End If

Loop

Setyear:

N = 0 : Gosub Printmonth
N = 1 : Gosub Printyear

Do                                                                                        '  

If Plus = 0 Then
Ye = Ye + 1
If Ye > 99 Then Ye = 0
Strye = Str(ye)
Strye = Format(strye , "00")
N = 1 : Gosub Printyear
Gosub Printmoonday
Waitms Wt
End If

If Minus = 0 Then
Ye = Ye - 1
If Ye > 100 Then Ye = 0
Strye = Str(ye)
Strye = Format(strye , "00")
N = 1 : Gosub Printyear
Gosub Printmoonday
Waitms Wt
End If

If Setting = 0 Then
Waitms Wt
Goto Setday
End If
'
Loop
'
Setday:
'
N = 0 : Gosub Printyear
N = 1 : Gosub Printday
'
Do                                                                                        '   

If Plus = 0 Then
Day = Day + 1
If Day > 7 Then Day = 1
N = 1 : Gosub Printday
Waitms Wt
End If

If Minus = 0 Then
Day = Day - 1
If Day < 1 Then Day = 7
N = 1 : Gosub Printday
Waitms Wt
End If

If Setting = 0 Then
Waitms Wt
Goto Saveset
End If

Loop

Saveset:                                                                                  '
'
N = 0 : Gosub Printday
N = 1
Gosub Printminute
Gosub Printhour
Gosub Printday
Gosub Printdat
Gosub Printmonth
Gosub Printyear
Gosub Printmoonday

Do                                                                                        '  DS1307    "Plus"
 N = 0
If Plus = 0 Then
 Ho = Makebcd(ho)
 Mi = Makebcd(mi)
 Day = Makebcd(day)
 Dat = Makebcd(dat)
 Mo = Makebcd(mo)
 Ye = Makebcd(ye)

 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 0
 I2cwbyte 0
 I2cwbyte Mi
 I2cwbyte Ho
 I2cwbyte Day
 I2cwbyte Dat
 I2cwbyte Mo
 I2cwbyte Ye
 I2cstop

 Goto Main                                                                                '     .  
 End If

If Setting = 0 Then
Waitms Wt                                                                                 '     
Goto Main
End If

Loop

Gettime:
I2cstart
I2cwbyte Ds1307w
I2cwbyte &H00
I2cstart
I2cwbyte Ds1307r
I2crbyte Secu , Ack
I2crbyte Mi , Ack
I2crbyte Ho , Ack
I2crbyte Day , Ack
I2crbyte Dat , Ack
I2crbyte Mo , Ack
I2crbyte Ye , Nack
I2cstop

Secu = Makedec(secu)
Mi = Makedec(mi)
Ho = Makedec(ho)
Day = Makedec(day)
Dat = Makedec(dat)
Mo = Makedec(mo)
Ye = Makedec(ye)
Return

Printhour:
Temptext = Str(ho)
Dig = Left(temptext , 1)
Bytetemp = Val(dig)
If Ho < 10 Then Print_big_digit 10 , 10 , 8 , N
If Ho > 9 Then Print_big_digit Bytetemp , 10 , 8 , N
Dig = Right(temptext , 1)
Bytetemp = Val(dig)
Print_big_digit Bytetemp , 10 , 11 , N

Return

Printminute:
Temptext = Str(mi)
Dig = Left(temptext , 1)
Bytetemp = Val(dig)
If Mi < 10 Then Print_big_digit 0 , 10 , 16 , N
If Mi > 9 Then Print_big_digit Bytetemp , 10 , 16 , N
Dig = Right(temptext , 1)
Bytetemp = Val(dig)
Print_big_digit Bytetemp , 10 , 19 , N
Return

Printsecond:
Temptext = Str(secu)
Dig = Left(temptext , 1)
Bytetemp = Val(dig)
If Secu < 10 Then Print_digit 0 , 11 , 23
If Secu > 9 Then Print_digit Bytetemp , 11 , 23
Dig = Right(temptext , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 11 , 25 ,
Bytetemp = Secu Mod 2
If Bytetemp = 1 Then
   Videochar &H3F , 11 , 15 , 0 , 0
   Led = 1
End If
If Bytetemp = 0 Then
   Videochar &H00 , 11 , 15 , 0 , 0
   Led = 0
End If
Return

Printday:
 '      ,    .      :-)
'Wa = 14 - mo
'Wa = Wa / 12
''Wy = 2000 + Ye
'Wy = Wy - wa
'Wm = 12 * Wa
'Wm = Mo + Wm
'Wm = Wm - 2
'Wtemp1 = Wy / 4
'Wtemp2 = Wy / 100
'Wtemp3 = Wy / 400
'Wtemp4 = 31 * Wm
'Wtemp4 = Wtemp4 / 12
'Wd = Dat + Wy
'Wd = Wd + Wtemp1
'Wd = Wd - wtemp2
'Wd = Wd + Wtemp3
'Wd = Wd + Wtemp4
'Wd = 7000 + Wd
'Temptext = Str(wd)
'Videotext Temptext , 9 , 7 , 0 , 0
'Wd = Wd Mod 7
'Strday = Str(wd)
'Videotext Temptext , 9 , 3 , 0 , 0


Select Case Day
         Case 1 : Strday = ""
         Case 2 : Strday = " "
         Case 3 : Strday = "   "
         Case 4 : Strday = "   "
         Case 5 : Strday = " !"
         Case 6 : Strday = "   "
         Case 7 : Strday = "   "
End Select
Videotext Strday , 14 , 20 , N , 0
Return


Printdat:
Temptext = Str(dat)
If Dat < 10 Then Videotext Temptext , 14 , 2 , N , 0 : Videotext " " , 14 , 1 , N , 0
If Dat > 9 Then Videotext Temptext , 14 , 1 , N , 0

Return

Printmonth:

Select Case Mo
         Case 1 : Strmo = ""
         Case 2 : Strmo = ""
         Case 3 : Strmo = ""
         Case 4 : Strmo = ""
         Case 5 : Strmo = ""
         Case 6 : Strmo = ""
         Case 7 : Strmo = ""
         Case 8 : Strmo = ""
         Case 9 : Strmo = ""
         Case 10 : Strmo = ""
         Case 11 : Strmo = ""
         Case 12 : Strmo = ""
End Select
Videotext "              " , 14 , 4 , N , 0
Videotext Strmo , 14 , 4 , N , 0
Bytetemp = Len(strmo)
Bytetemp = Bytetemp + 5
Temptext = Str(ye)
Temptext = "20" + Temptext
Videotext Temptext , 14 , Bytetemp , 0 , 0
Return

Printyear:
Bytetemp = Len(strmo)
Bytetemp = Bytetemp + 5
'Videotext "             " , 14 , 4 , 0 , 0
'Videotext Strmo , 14 , 4 , 0 , 0
Temptext = Str(ye)
Temptext = Format(temptext , "00")
Temptext = "20" + Temptext
Videotext Temptext , 14 , Bytetemp , N , 0
Return

'===        
Printmoonday:
Moonday = 2000 + Ye
If Mo = 1 Or Mo = 2 Then Moonday = Moonday - 1
Moonday = Moonday / 19
Moonday = Frac(moonday)
Moonday = Moonday * 209
Moonday = Round(moonday)
Moonday = Moonday + Mo
If Mo = 1 Or Mo = 2 Then Moonday = Moonday + 12
Moonday = Moonday - 3
Moonday = Moonday + Dat
Moonday = Moonday / 30
Moonday = Frac(moonday)
Moonday = Moonday * 30
Moonday = Round(moonday)

'===    
Temptext = Str(moonday)
Temptext = Format(temptext , "00")

If Moonday < 10 Then
   Videotext " " , 10 , 3 , 0 , 0
   Videotext Temptext , 10 , 4 , 0 , 0
Else
   Videotext Temptext , 10 , 3 , 0 , 0
End If
Videotext "  " , 10 , 5 , 0 , 0
'=================================

'===   
If Moonday > 0 And Moonday < 3 Then Phase = 0
If Moonday > 28 And Moonday < 31 Then Phase = 0
If Moonday > 2 And Moonday < 6 Then Phase = 1
If Moonday > 5 And Moonday < 11 Then Phase = 2
If Moonday > 10 And Moonday < 14 Then Phase = 3
If Moonday > 13 And Moonday < 18 Then Phase = 4
If Moonday > 17 And Moonday < 22 Then Phase = 5
If Moonday > 21 And Moonday < 25 Then Phase = 6
If Moonday > 24 And Moonday < 29 Then Phase = 7

Print_phase Phase , 11 , 3                                                                '    

Bmp085:
   Call Bmp085_initiate_measurement(1)                                                    '1 = Temperature Measurement
   Call Bmp085_read_u_temp()

   Call Bmp085_initiate_measurement(5)                                                    'Very High Resolution Pressure Measurement (OSS=3)
                                 '  ^  type in Measurement_type  !!!! <<<<<----------------------------------------
   Call Bmp085_read_u_press()

   Call Bmp085_calc_temp()                                                                'Calculate calibrated Temperature
   Call Bmp085_calc_pressure()                                                            'Calculate calibrated Pressure

T = T * 10
Temperature = Str(t)
Temperature = Format(temperature , "000")
' Videotext Temperature , 7 , 15 ,0,0
Temperature = Left(temperature , 3)
Dig = Left(temperature , 1)
Bytetemp = Val(dig)
If Bytetemp = 0 Then Print_digit 11 , 4 , 19
If Bytetemp > 0 Then Print_digit Bytetemp , 4 , 19
Dig = Mid(temperature , 2 , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 4 , 21
'Videochar &H5E , 5 , 23 , 0 , 0
Dig = Right(temperature , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 4 , 24

P = P * 0.75
Pressure = Str(p)
Pressure = Format(pressure , "000")
Temptext = Left(pressure , 3)
Dig = Left(temptext , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 1 , 4
Dig = Mid(temptext , 2 , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 1 , 6
Dig = Right(temptext , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 1 , 8

Return


Presslog:
Tlog = Ho Mod 6                                                                           'e         
If Secu = 18 And Mi = 0 And Tlog = 0 Then
 If P < 735 Then Pl = 0
 If P > 734 And P < 740 Then Pl = 9
 If P > 739 And P < 745 Then Pl = 8
 If P > 744 And P < 750 Then Pl = 7
 If P > 749 And P < 755 Then Pl = 6
 If P > 754 And P < 760 Then Pl = 5
 If P > 759 And P < 765 Then Pl = 4
 If P > 764 And P < 770 Then Pl = 3
 If P > 769 And P < 775 Then Pl = 2
 If P > 774 Then Pl = 1
 'Temptext = Str(ho)
 'Videotext Temptext , 9 , 27 , 0 , 0

 Pl12 = Pl11                                                                              '  
 Pl11 = Pl10
 Pl10 = Pl9
 Pl9 = Pl8
 Pl8 = Pl7
 Pl7 = Pl6
 Pl6 = Pl5
 Pl5 = Pl4
 Pl4 = Pl3
 Pl3 = Pl2
 Pl2 = Pl1
 Pl1 = Pl

 Epl12 = Pl12                                                                             '   EEPROM 
 Epl11 = Pl11
 Epl10 = Pl10
 Epl9 = Pl9
 Epl8 = Pl8
 Epl7 = Pl7
 Epl6 = Pl6
 Epl5 = Pl5
 Epl4 = Pl4
 Epl3 = Pl3
 Epl2 = Pl2
 Epl1 = Pl1

End If

Videochar Pl12 , 7 , 9 , 0 , 0                                                            '  
Videochar Pl11 , 7 , 10 , 0 , 0
Videochar Pl10 , 7 , 11 , 0 , 0
Videochar Pl9 , 7 , 12 , 0 , 0
Videochar Pl8 , 7 , 13 , 0 , 0
Videochar Pl7 , 7 , 14 , 0 , 0
Videochar Pl6 , 7 , 15 , 0 , 0
Videochar Pl5 , 7 , 16 , 0 , 0
Videochar Pl4 , 7 , 17 , 0 , 0
Videochar Pl3 , 7 , 18 , 0 , 0
Videochar Pl2 , 7 , 19 , 0 , 0
Videochar Pl1 , 7 , 20 , 0 , 0

Return


Dht22:
                                                                                   '       
Tempout = 0
Hum = 0

Call Read_dht22
'  
Chs = Hb(2) + Hb(3)
Chs = Chs + Hb(4)
Chs = Chs + Hb(5)
'  
If Chs = Hb(1) Then
   If Hu(1).15 = 1 Then
      Hu(1).15 = 0
      Tempout = 0 - Hu(1)
   Else
      Tempout = Hu(1)
   End If
   Hum = Hu(2)
Else
'   -  
    Tempout = 0
    Hum = 0
End If

Hum = Hum / 10
Bytetemp = Round(hum)
Temptext = Str(bytetemp)
Dig = Left(temptext , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 4 , 6
Dig = Right(temptext , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 4 , 8

If Tempout < Tempmin Then Tempmin = Tempout
If Tempout > Tempmax Then Tempmax = Tempout

Temptext = Str(tempout)
Temptext = Format(temptext , "000")
Temptext = Right(temptext , 3)

Dig = Right(temptext , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 1 , 24

Dig = Mid(temptext , 2 , 1)
Bytetemp = Val(dig)
Print_digit Bytetemp , 1 , 21

Dig = Left(temptext , 1)
Bytetemp = Val(dig)

If Tempout < 0 Then
   If Tempout < -99 Then
      Print_digit Bytetemp , 1 , 19
      Print_digit 10 , 1 , 17
   End If
   If Tempout > -100 Then
      Print_digit 11 , 1 , 17
      Print_digit 10 , 1 , 19
   End If
End If
If Tempout > 0 Or Tempout = 0 Then
   If Tempout < 100 Then
      Print_digit 11 , 1 , 17
      Print_digit 11 , 1 , 19
   End If
   If Tempout > 99 Then
      Print_digit 11 , 1 , 17
      Print_digit Bytetemp , 1 , 19
   End If

End If

Temptext = Str(tempmin)
If Tempmin < 0 Then
   If Tempmin < -99 Then
     Temptext = Format(temptext , "-00.0")
     Videotext Temptext , 7 , 2 , 0 , 0
   End If
   If Tempmin > -100 Then
     Temptext = Format(temptext , "-0.0")
     Videotext " " , 7 , 2 , 0 , 0
     Videotext Temptext , 7 , 3 , 0 , 0
   End If
End If
If Tempmin > 0 Or Tempmin = 0 Then
   If Tempmin < 100 Then
      Temptext = Format(temptext , "0.0")
      Videotext "  " , 7 , 2 , 0 , 0
      Videotext Temptext , 7 , 4 , 0 , 0
   End If
   If Tempmin > 99 Then
      Temptext = Format(temptext , "00.0")
      Videotext " " , 7 , 2 , 0 , 0
      Videotext Temptext , 7 , 3 , 0 , 0
   End If
End If

Temptext = Str(tempmax)
If Tempmax < 0 Then
   If Tempmax < -99 Then
     Temptext = Format(temptext , "-00.0")
     Videotext Temptext , 7 , 23 , 0 , 0
   End If
   If Tempmax > -100 Then
     Temptext = Format(temptext , "-0.0")
     Videotext " " , 7 , 23 , 0 , 0
     Videotext Temptext , 7 , 24 , 0 , 0
   End If
End If
If Tempmax > 0 Or Tempmax = 0 Then
   If Tempmax < 100 Then
      Temptext = Format(temptext , "0.0")
      Videotext "  " , 7 , 23 , 0 , 0
      Videotext Temptext , 7 , 25 , 0 , 0
   End If
   If Tempmax > 99 Then
      Temptext = Format(temptext , "00.0")
      Videotext " " , 7 , 23 , 0 , 0
      Videotext Temptext , 7 , 24 , 0 , 0
   End If
End If

Return





'=== Subroutines for MAX7456===
Sub Initmax7456()

 Writereg Vm0 , &B01001110                                                                '   MAX7456
 Waitms 200
' Writereg Vm0 , &B01001100
 Writereg Vm0 , &B01111100                                                                '    MAX7456. . http://datasheets.maximintegrated.com/en/ds/MAX7456.pdf  . 25
 Writereg Vm1 , &B00001111
 Writereg Dmm , &B01000000
 Writereg Hos , Hosreg                                                                    '     (datasheet . 26-27).
 Writereg Vos , Vosreg

End Sub
'===    ==
Sub Videotext(byval Text As String , Byval Ypos As Byte , Byval Xpos As Byte , Blnk As Byte , Inv As Byte)

 Local Charcount As Byte , Tempstring As String * 1 , Tempbyte As Byte , Position As Word , Chars As Byte , Attribute As Byte
 Attribute = 0                                                                            '    
 Charcount = Len(text) - 1                                                                '      1,      0
 For Chars = 0 To Charcount                                                               '  ,     
  Position = Ypos * 30                                                                    ',       30 =   
  Position = Position + Xpos                                                              'Position + the xpos
  Position = Position + Chars                                                             'Position +      

  If Blnk = 1 Then                                                                        '   -   
    Set Attribute.6
  Else
    Reset Attribute.6
  End If
  If Inv = 1 Then                                                                         '   -   
    Set Attribute.5
  Else
    Reset Attribute.5
  End If

 Tempbyte = Chars + 1                                                                     'Need the character position from the textstring
 Tempstring = Mid(text , Tempbyte , 1)                                                    'Take out 1 character that we need to handle now
 Tempbyte = Asc(tempstring)
 Regdata = High(position)                                                                 'Put the highbyte of position in the regdatabuffer
 Writereg Dmah , Regdata                                                                  '   
 Regdata = Low(position)                                                                  'Put the lowbyte of position in the regdatabuffer
 Writereg Dmal , Regdata                                                                  'Write the data to the register
 Writereg Dmdi , Tempbyte                                                                 'Write the data to the DisplayMemory register
 Regdata = High(position)                                                                 'Put the highbyte of position in the regdatabuffer
 Regdata = Regdata Or &B00000010                                                          'Set bit1 for the character attribute
 Writereg Dmah , Regdata                                                                  'Write the data to the register
 Regdata = Low(position)                                                                  'Put the lowbyte of position in the regdatabuffer
 Writereg Dmal , Regdata                                                                  'Write the data to the register
 Writereg Dmdi , Attribute                                                                'Write the attribute to the DisplayMemory register

 Next Charcount                                                                           'Carcount

End Sub

'===   
Sub Videochar(byval Char As Byte , Byval Ypos As Byte , Byval Xpos As Byte , Byval Blnk As Byte , Byval Inv As Byte)
Local Tempbyte As Byte , Position As Word , Attribute As Byte
Attribute = 0                                                                             '    
 Position = Ypos * 30                                                                     ',       30 =   
 Position = Position + Xpos                                                               'Position + the xpos

 If Blnk = 1 Then
    Set Attribute.6
  Else
    Reset Attribute.6
  End If
  If Inv = 1 Then
    Set Attribute.5
  Else
    Reset Attribute.5
  End If

 Tempbyte = Char
 Regdata = High(position)                                                                 'Put the highbyte of position in the regdatabuffer
 Writereg Dmah , Regdata                                                                  '   
 Regdata = Low(position)                                                                  'Put the lowbyte of position in the regdatabuffer
 Writereg Dmal , Regdata                                                                  'Write the data to the register
 Writereg Dmdi , Tempbyte                                                                 'Write the data to the DisplayMemory register
 Regdata = High(position)                                                                 'Put the highbyte of position in the regdatabuffer
 Regdata = Regdata Or &B00000010                                                          'Set bit1 for the character attribute
 Writereg Dmah , Regdata                                                                  'Write the data to the register
 Regdata = Low(position)                                                                  'Put the lowbyte of position in the regdatabuffer
 Writereg Dmal , Regdata                                                                  'Write the data to the register
 Writereg Dmdi , Attribute                                                                'Write the attribute to the DisplayMemory register

End Sub

Sub Writereg(byval Regaddr As Byte , Byval Regdata As Byte)

 While Vsync = M
 Wend
 Buffer(1) = Regaddr                                                                      '   
 Buffer(2) = Regdata
 Spiout Buffer(1) , 2                                                                     '   SPI

End Sub

'===    () 33
Sub Print_big_digit(byval Digit As Byte , Byval Yp As Byte , Byval Xp As Byte , Byval Blnk As Byte)

  Local A As Byte , B As Byte , X As Byte , Y As Byte , Char As Byte
  Digit = Digit * 9
  For A = 0 To 2
       Y = Yp + A
       For B = 0 To 2
           Char = Lookup(digit , Bigdigit)
           X = Xp + B
           Videochar Char , Y , X , Blnk , 0
           Digit = Digit + 1
      Next B
  Next A

End Sub

'===     22
Sub Print_digit(byval Digit As Byte , Byval Yp As Byte , Byval Xp As Byte)

  Local A As Byte , B As Byte , X As Byte , Y As Byte , Char As Byte
  Digit = Digit * 4
  For A = 0 To 1
       Y = Yp + A
       For B = 0 To 1
           Char = Lookup(digit , Digit)
           X = Xp + B
           Videochar Char , Y , X , 0 , 0
           Digit = Digit + 1
       Next B
  Next A

End Sub

'===    32
Sub Print_phase(byval Digit As Byte , Byval Yp As Byte , Byval Xp As Byte)

  Local A As Byte , B As Byte , X As Byte , Y As Byte , Char As Byte
  Digit = Digit * 6
  For A = 0 To 1
       Y = Yp + A
       For B = 0 To 2
           Char = Lookup(digit , Moonphase)
           X = Xp + B
           Videochar Char , Y , X , 0 , 0
           Digit = Digit + 1
       Next B
  Next A

End Sub

Sub Bmp085_read_calibration_data()

 'Read Calibration Data from Sensor (11x 16Bit Values)
 'for optional Error checking -->  None of the Values are &H0000 or &HFFFF
  Calibration_data(1) = &HAA
  I2creceive Bmp085_write , Calibration_data(1) , 1 , 22

 'We need to swap High Byte with Low Byte of all integers
  Swap Ac1
  Swap Ac2
  Swap Ac3
  Swap Ac4
  Swap Ac5
  Swap Ac6

  Swap B1
  Swap B2
  Swap Mb
  Swap Mc
  Swap Md


 C3 = 0.004882812499 * Ac3
 C4 = 0.000000030517 * Ac4
 B11 = 0.00002384186 * B1
 C5 = 0.000000190734 * Ac5
 C6 = Ac6
 Mc1 = 0.08 * Mc
 Md1 = Md / 160.0000121
 X0 = Ac1
 X1 = 0.019531250 * Ac2
 X2 = 0.000762939453 * B2
 Y0 = 32768 * C4
 Y1 = C4 * C3
 Y2 = C4 * B11
 P0 = 2.36437500
 P1 = 0.9929838181
 P2 = 0.000004420872


End Sub

'-------------------------------------------------------------------------------------------------------

Sub Bmp085_initiate_measurement(byval Measurement_type As Byte)
    Local M_type As Byte , Wait_time As Byte


        Select Case Measurement_type
          Case 1:                                                                         '1 = Temparature Measurement
             M_type = &H2E
             Wait_time = 5                                                                'ms
           Case 2:
             M_type = &H34                                                                '2 = Ultra Low Power Pressure Measurement (OSS = 0)
             Wait_time = 5                                                                'ms
           Case 3:
             M_type = &H74                                                                '3 = Standard Pressure Measurement (OSS = 1)
             Wait_time = 8                                                                'ms
           Case 4:
             M_type = &HB4                                                                '4 = High Resolution Pressure Measurement (OSS = 2)
             Wait_time = 14                                                               'ms
           Case 5:
             M_type = &HF4                                                                '5 =Ultra High Resolution Pressure Measurement (OSS = 3)
             Wait_time = 26                                                               'ms
        End Select


         I2cstart
         I2cwbyte Bmp085_write
         I2cwbyte &HF4
         I2cwbyte M_type
         I2cstop

         'Wait_time = between 5 and 26ms depending on above selected measurement method
         Waitms Wait_time



End Sub

'----------------------------------------------------------------------------------------------------
Sub Bmp085_read_u_temp()

  I2cstart
  I2cwbyte Bmp085_write
  I2cwbyte &HF6

  I2crepstart
  I2cwbyte Bmp085_read
  I2crbyte U_temp_high , Ack
  I2crbyte U_temp_low , Nack
  I2cstop

  Tu = U_temperatur
End Sub

'----------------------------------------------------------------------------------------------------

Sub Bmp085_read_u_press()

   I2c_receive_buf(1) = &HF6

   I2creceive Bmp085_write , I2c_receive_buf(1) , 1 , 3

Pu = 256 * I2c_receive_buf(1)
Pu = Pu + I2c_receive_buf(2)
Temp = I2c_receive_buf(3) / 256
Pu = Pu + Temp

End Sub


'---------------------------------------------------------------------------------------
Sub Bmp085_calc_temp()
' Calculate true Temperature

 Alfa = Tu - C6
 Alfa = Alfa * C5
 Temp = Alfa + Md1
 Temp = Mc1 / Temp

 T = Alfa + Temp
 Tv = T


 End Sub

'---------------------------------------------------------------------------------------
Sub Bmp085_calc_pressure()

'      BMP085-Calcs.PDF

 S = T - 25
 X = X1 * S
 X = X + X0
 Temp = S * S
 Temp = Temp * X2
 X = X + Temp

 Y = Y1 * S
 Y = Y + Y0
 Temp = S * S
 Temp = Y2 * Temp
 Y = Y + Temp

 Z = Pu - X
 Z = Z / Y

 P = P1 * Z
 P = P + P0
 Temp = Z * Z
 Temp = Temp * P2
 Pv = P + Temp

 'P_corrv = P * 1.09328                                                                    ' 



End Sub
'------------------------------------------------------------------------------


Sub Read_dht22
Local Y As Byte
   Count = 1
Kod = 0
Hb(1) = 0

   Config Pind.6 = Output : Pind.6 = 0                                                    ' request data
   Waitms 20                                                                              ' wait 20 ms
   Config Pind.6 = Input                                                                  ' wait for data, receive data
   Bitwait Pind.6 , Reset
   While Count < 42                                                                       '
 Y = Count - 1                                                                            '
 Y = 40 - Y
      Pulsein D , Pind , 6 , 1
     If D > Min_time Then Toggle Hb(1).y
      Incr Count

  Wend
End Sub


' 
Bigdigit:
Data &H80 , &H81 , &H82 , &HB0 , &H00 , &HB1 , &H86 , &H87 , &H88                         '0
Data &H00 , &H00 , &H8B , &H00 , &H00 , &HB1 , &H00 , &H00 , &HB9                         '1
Data &H8A , &H81 , &H82 , &H8D , &H84 , &HB5 , &H86 , &H87 , &HB8                         '2
Data &H8A , &H81 , &H82 , &H8F , &H84 , &H85 , &HB6 , &H87 , &H88                         '3
Data &H89 , &H00 , &H8B , &H8E , &H84 , &H85 , &H00 , &H00 , &HB9                         '4
Data &H80 , &H81 , &H8C , &H8E , &H84 , &HB4 , &HB6 , &H87 , &H88                         '5
Data &H80 , &H81 , &H8C , &H83 , &H84 , &HB4 , &H86 , &H87 , &H88                         '6
Data &H8A , &H81 , &H82 , &H00 , &H00 , &HB1 , &H00 , &H00 , &HB9                         '7
Data &H80 , &H81 , &H82 , &H83 , &H84 , &H85 , &H86 , &H87 , &H88                         '8
Data &H80 , &H81 , &H82 , &H8E , &H84 , &H85 , &HB6 , &H87 , &H88                         '9
Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00                         'blank

' 
Digit:
Data &H14 , &H15 , &H16 , &H17                                                            '0
Data &H00 , &H18 , &H00 , &H19                                                            '1
Data &H1A , &H11 , &H12 , &H1B                                                            '2
Data &H1A , &H11 , &H1C , &H13                                                            '3
Data &H0E , &H0A , &H0C , &H0D                                                            '4
Data &H10 , &H1D , &H1C , &H13                                                            '5
Data &H10 , &H1D , &H12 , &H13                                                            '6
Data &H0B , &H15 , &H00 , &H18                                                            '7
Data &H10 , &H11 , &H12 , &H13                                                            '8
Data &H10 , &H11 , &H1C , &H13                                                            '9
Data &H1E , &H0F , &H0C , &H1F                                                            'minus
Data &H00 , &H00 , &H00 , &H00                                                            'blank

' 
Moonphase:
Data &H60 , &H61 , &H62 , &H70 , &H71 , &H72                                              '1
Data &H60 , &H66 , &H67 , &H70 , &H76 , &H77                                              '2
Data &H60 , &H6E , &H65 , &H70 , &H7E , &H75                                              '3
Data &H6A , &H6B , &H65 , &H7A , &H7B , &H75                                              '4
Data &H63 , &H64 , &H65 , &H73 , &H74 , &H75                                              '5
Data &H63 , &H68 , &H69 , &H73 , &H78 , &H79                                              '6
Data &H63 , &H6F , &H62 , &H73 , &H7F , &H72                                              '7
Data &H6C , &H6D , &H62 , &H7C , &H7D , &H72                                              '8